<html>
<head>
<title>OgreSkeletonSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSkeletonSerializer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSkeletonSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SkeletonSerializer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SkeletonSerializer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSkeleton_8h.html">OgreSkeleton.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSerializer_8h.html">OgreSerializer.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00039"></a><a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa">00039</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa" title="Skeleton compatibility versions.">SkeletonVersion</a> 
<a name="l00040"></a>00040     {
<a name="l00042"></a><a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa7f9c75eb5146038296367ff593ea088c">00042</a>         <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa7f9c75eb5146038296367ff593ea088c" title="OGRE version v1.0+.">SKELETON_VERSION_1_0</a>,
<a name="l00044"></a><a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa40eb0a9c9147623fc32b802587261311">00044</a>         <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa40eb0a9c9147623fc32b802587261311" title="OGRE version v1.8+.">SKELETON_VERSION_1_8</a>,
<a name="l00045"></a>00045         
<a name="l00047"></a><a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa49b1f6d28821c5e03dff7b1334d5a6bd">00047</a>         <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa49b1f6d28821c5e03dff7b1334d5a6bd" title="Latest version available.">SKELETON_VERSION_LATEST</a> = 100
<a name="l00048"></a>00048     };
<a name="l00049"></a>00049 
<a name="l00068"></a><a class="code" href="classOgre_1_1SkeletonSerializer.html">00068</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SkeletonSerializer.html" title="Class for serialising skeleton data to/from an OGRE .skeleton file.">SkeletonSerializer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070         
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a>00072         <a class="code" href="classOgre_1_1SkeletonSerializer.html" title="Class for serialising skeleton data to/from an OGRE .skeleton file.">SkeletonSerializer</a>();
<a name="l00073"></a>00073         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1SkeletonSerializer.html" title="Class for serialising skeleton data to/from an OGRE .skeleton file.">SkeletonSerializer</a>();
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00084"></a>00084         <span class="keywordtype">void</span> exportSkeleton(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkeleton, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename,
<a name="l00085"></a>00085             <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa" title="Skeleton compatibility versions.">SkeletonVersion</a> ver = <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa49b1f6d28821c5e03dff7b1334d5a6bd" title="Latest version available.">SKELETON_VERSION_LATEST</a>, <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00086"></a>00086 
<a name="l00095"></a>00095         <span class="keywordtype">void</span> exportSkeleton(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkeleton, <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> stream,
<a name="l00096"></a>00096             <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa" title="Skeleton compatibility versions.">SkeletonVersion</a> ver = <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffaa49b1f6d28821c5e03dff7b1334d5a6bd" title="Latest version available.">SKELETON_VERSION_LATEST</a>, <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00104"></a>00104         <span class="keywordtype">void</span> importSkeleton(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pDest);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         <span class="comment">// TODO: provide Cal3D importer?</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108     <span class="keyword">protected</span>:
<a name="l00109"></a>00109         
<a name="l00110"></a>00110         <span class="keywordtype">void</span> setWorkingVersion(<a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa" title="Skeleton compatibility versions.">SkeletonVersion</a> ver);
<a name="l00111"></a>00111         
<a name="l00112"></a>00112         <span class="comment">// Internal export methods</span>
<a name="l00113"></a>00113         <span class="keywordtype">void</span> writeSkeleton(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa" title="Skeleton compatibility versions.">SkeletonVersion</a> ver);
<a name="l00114"></a>00114         <span class="keywordtype">void</span> writeBone(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* pBone);
<a name="l00115"></a>00115         <span class="keywordtype">void</span> writeBoneParent(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> boneId, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> parentId);
<a name="l00116"></a>00116         <span class="keywordtype">void</span> writeAnimation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* anim, <a class="code" href="namespaceOgre.html#ada8fa477cd38aab81e40b645c60fdffa" title="Skeleton compatibility versions.">SkeletonVersion</a> ver);
<a name="l00117"></a>00117         <span class="keywordtype">void</span> writeAnimationTrack(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* track);
<a name="l00118"></a>00118         <span class="keywordtype">void</span> writeKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* key);
<a name="l00119"></a>00119         <span class="keywordtype">void</span> writeSkeletonAnimationLink(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, 
<a name="l00120"></a>00120             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>&amp; link);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122         <span class="comment">// Internal import methods</span>
<a name="l00123"></a>00123         <span class="keywordtype">void</span> readFileHeader(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream);
<a name="l00124"></a>00124         <span class="keywordtype">void</span> readBone(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00125"></a>00125         <span class="keywordtype">void</span> readBoneParent(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00126"></a>00126         <span class="keywordtype">void</span> readAnimation(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00127"></a>00127         <span class="keywordtype">void</span> readAnimationTrack(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* anim, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00128"></a>00128         <span class="keywordtype">void</span> readKeyFrame(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* track, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00129"></a>00129         <span class="keywordtype">void</span> readSkeletonAnimationLink(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131         <span class="keywordtype">size_t</span> calcBoneSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* pBone);
<a name="l00132"></a>00132         <span class="keywordtype">size_t</span> calcBoneSizeWithoutScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* pBone);
<a name="l00133"></a>00133         <span class="keywordtype">size_t</span> calcBoneParentSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00134"></a>00134         <span class="keywordtype">size_t</span> calcAnimationSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* pAnim);
<a name="l00135"></a>00135         <span class="keywordtype">size_t</span> calcAnimationTrackSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* pTrack);
<a name="l00136"></a>00136         <span class="keywordtype">size_t</span> calcKeyFrameSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* pKey);
<a name="l00137"></a>00137         <span class="keywordtype">size_t</span> calcKeyFrameSizeWithoutScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* pKey);
<a name="l00138"></a>00138         <span class="keywordtype">size_t</span> calcSkeletonAnimationLinkSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, 
<a name="l00139"></a>00139             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>&amp; link);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     };
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
